org.apache.activemq.artemis.spi.core.remoting.ssl

## Interface SSLContextFactory

- All Superinterfaces:
    Comparable<SSLContextFactory>

      public interface SSLContextFactory
      extends Comparable<SSLContextFactory>

  Service interface to create a SSLContext for a configuration. This is NOT used by OpenSSL. To create and use your own implementation you need to create a file `META-INF/services/org.apache.activemq.artemis.spi.core.remoting.ssl.SSLContextFactory` in your jar and fill it with the full qualified name of your implementation.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static org.jboss.logging.Logger` | `log`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `default void` | `clearSSLContexts()`
    `default int` | `compareTo(SSLContextFactory other)`
    `int` | `getPriority()` The priority for the SSLContextFactory when resolving the service to get the implementation.
    `default SSLContext` | `getSSLContext(Map<String,Object> configuration, String keystoreProvider, String keystorePath, String keystoreType, String keystorePassword, String truststoreProvider, String truststorePath, String truststoreType, String truststorePassword, String crlPath, String trustManagerFactoryPlugin, boolean trustAll)` Deprecated. use `getSSLContext(SSLContextConfig, Map)` instead
    `default SSLContext` | `getSSLContext(SSLContextConfig config, Map<String,Object> additionalOpts)`

- - ### Field Detail

    - #### log

          static final org.jboss.logging.Logger log

  - ### Method Detail

    - #### getSSLContext

          @Deprecated
          default SSLContext getSSLContext(Map<String,Object> configuration,
                                                       String keystoreProvider,
                                                       String keystorePath,
                                                       String keystoreType,
                                                       String keystorePassword,
                                                       String truststoreProvider,
                                                       String truststorePath,
                                                       String truststoreType,
                                                       String truststorePassword,
                                                       String crlPath,
                                                       String trustManagerFactoryPlugin,
                                                       boolean trustAll)
                                                throws Exception

      Deprecated. use `getSSLContext(SSLContextConfig, Map)` instead
      Returns:
        an `SSLContext` for the given configuration.
      Throws:
        `Exception`

    - #### getSSLContext

          default SSLContext getSSLContext(SSLContextConfig config,
                                           Map<String,Object> additionalOpts)
                                    throws Exception

      Parameters:
        `additionalOpts` - implementation specific additional options.
      Returns:
        an `SSLContext` for the given configuration.
      Throws:
        `Exception`

    - #### clearSSLContexts

          default void clearSSLContexts()

    - #### getPriority

          int getPriority()

      The priority for the SSLContextFactory when resolving the service to get the implementation. This is used when selecting the implementation when several implementations are loaded. The highest priority implementation will be used.
      Returns:
        the priority.

    - #### compareTo

          default int compareTo(SSLContextFactory other)

      Specified by:
        `compareTo` in interface `Comparable<SSLContextFactory>`

Copyright © 2021 The Apache Software Foundation. All rights reserved.